{% set map=miz.mission.theatre|lower %}

<style>
    #markerAirport {
        width: 20px;
        height: 20px;
        border: 1px solid #088;
        border-radius: 10px;
        background-color: #0FF;
        opacity: 0.5;
    }

    .markerWaypoint {
        width: 20px;
        height: 20px;
        border-radius: 10px;
        opacity: 0.8;
        text-align: center;
    }

    .markerRed {
        border: 1px solid darkred;
        background-color: red;
        color: black;
    }

    .markerGreen {
        border: 1px solid darkgreen;
        background-color: green;
        color: black;
    }

    .markerBlue {
        border: 1px solid darkblue;
        background-color: blue;
        color: white;
    }

    .markerYellow {
        border: 1px solid saddlebrown;
        background-color: yellow;
        color: black;
    }

    .markerBullseye {
        width: 20px;
        height: 20px;
        opacity: 0.8;
        text-align: center;
    }

    .markerBullseyeBlue {
        background-image: url('/img/bullseye_blue_20.png');
    }

    .markerBullseyeRed {
        background-image: url('/img/bullseye_red_20.png');
    }

</style>
<div id="mapdiv" class="map"></div>
<div id="markerAirport" title="Marker"></div>

{% set coalitionBlue=miz.mission.coalition('blue') %}
{% set coalitionRed=miz.mission.coalition('red') %}

{% if side == 'blue' or side == 'mission_maker' %}
    <div id="markerBullseyeBlue" title="Bullseye {{ coalitionBlue.bullseye | xyToLL(map) | latLongDec }}" class="markerBullseye markerBullseyeBlue"></div>
{% endif %}
{% if side == 'red' or side == 'mission_maker' %}
    <div id="markerBullseyeRed" title="Bullseye {{ coalitionRed.bullseye | xyToLL(map) | latLongDec }}" class="markerBullseye markerBullseyeRed"></div>
{% endif %}

{#{% if side == 'blue' or side == 'mission_maker' %}#}
    {#{% set coalition=miz.mission.coalition('blue') %}#}
{#{% elseif side == 'red' or side == 'mission_maker' %}#}
    {#{% set coalition=miz.mission.coalition('red') %}#}
{#{% endif %}#}

{# create waypoints icons #}
    {% for id,grp in miz.mission.groups %}
        {% if grp.id == group.id or grp.displayWaypoint %}
            {% for waypointNum,waypoint in grp.route.waypoints %}
                <div id="waypoint_{{ grp.id }}_{{ waypointNum }}" class="markerWaypoint markerBlue waypoint_{{ grp.id }}" title="{{ waypointNum }}">{{ waypointNum }}</div>
            {% endfor %}
        {% endif %}
    {% endfor %}
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/openlayers/4.6.5/ol.css"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/openlayers/4.6.5/ol.js"></script>
<script>

</script>

{# display groups list #}
<div class="row">
    {% for id,grp in miz.mission.groups %}
        {% if grp.id == group.id or grp.stroke %}
            <div class="col-md-3 col-sm-6">
                <input id="btnToggleGroup{{ id }}" type="checkbox" {% if grp.id == group.id %}checked="checked"{% endif %}> {{ grp.name }}
            </div>
        {% endif %}
    {% endfor %}
</div>

<div id="map" class="svg-container"></div>

{#<div class="row">#}
    {#<div class="col-sm-12">#}
        {#{% for zone in miz.mission.triggerZones %}#}
            {#{{ dump(zone) }}#}
        {#{% endfor %}#}
    {#</div>#}
{#</div>#}
<script type="application/javascript">

    $(document).ready(function () {
        {# draw track #}
        var groupWaypoints = new Array();
        {% for id,grp in miz.mission.groups %}
        {% if grp.id == group.id or grp.coalition.name == side or side == "mission_maker" or (grp.stroke or grp.displayWaypoint) %}
        var waypoints = new Array();
        {% for waypointNum,waypoint in grp.route.waypoints %}
        waypoints.push([{{ waypoint.position | xyToLong(map) }}, {{ waypoint.position | xyToLat(map) }}]);
        {% endfor %}
        groupWaypoints[{{ id }}] = waypoints;
        {% endif %}
        {% endfor %}

        var lineStyle = new ol.style.Style({
            stroke: new ol.style.Stroke({
                color: '#ff0000',
                width: 2
            })
        });

        var mapLayer = new ol.layer.Tile({
            title: ' map',
            source: new ol.source.OSM({
                attributions: [
                    'All maps © <a href="https://www.opencyclemap.org/">OpenCycleMap</a>',
                    ol.source.OSM.ATTRIBUTION
                ],
                url: 'https://{a-c}.tile.thunderforest.com/cycle/{z}/{x}/{y}.png' +
                '?apikey=206533bed70f499ca9032f6fd38fa3a3'
            })
        });

        var layers = [];
        layers.push(mapLayer);

        {% set numLayer=0 %}
        {% for id,grp in miz.mission.groups %}
        {% if grp.id == group.id or grp.coalition.name == side or side == "mission_maker" or (grp.stroke or grp.displayWaypoint) %}
        {% set numLayer=numLayer+1 %}
        layers.push(new ol.layer.Vector({
            title: '{{ grp.name }}',
            source: new ol.source.Vector({
                features: [new ol.Feature({
                    geometry: new ol.geom.LineString(groupWaypoints[{{ id }}]).transform('EPSG:4326', 'EPSG:3857'),
                    name: 'Line'
                })]
            }),
            style: [lineStyle]
        }));
        {% endif %}
        {% endfor %}

        var zoom = 8;

        //var pos = ol.proj.fromLonLat([16.3725, 48.208889]);
        {% if map == "caucasus" %}
        var centerPosition = ol.proj.fromLonLat([42.045493, 42.240306]);
        {% elseif map == "persiangulf" %}
        var centerPosition = ol.proj.fromLonLat([55.31, 25.21]);
        {% endif %}

        // mouse position
        var mposition = new ol.control.MousePosition({
            undefinedHTML: '<span class="label label-success"><i class="fa fa-map-marker"></i> No data</span>',
            projection: 'EPSG:4326',
            coordinateFormat: function (coordinate) {
                return ol.coordinate.format(coordinate, '<span class="label label-success"><i class="fa fa-map-marker"></i> {x} ° | {y} °</span>', 4);
            }
        });

        var map = new ol.Map({
            controls: ol.control.defaults({
                attribution: true,
            }).extend([
                //attribution,
                //fscreen,
                mposition,
                //overview,
                //scale,
                //zslider,
                //zextent
            ]),
            layers: layers,
            target: 'mapdiv',
            view: new ol.View({
                center: centerPosition,
                zoom: zoom
            })
        });

        var marker = new ol.Overlay({
            position: centerPosition,
            positioning: 'center-center',
            element: document.getElementById('markerAirport'),
            stopEvent: false
        });
        map.addOverlay(marker);

        {# add bullseye #}
        {% if side == 'blue' or side == 'mission_maker' %}
        var markerBullseyeBlue = new ol.Overlay({
            position: ol.proj.fromLonLat([{{ coalitionBlue.bullseye | xyToLong(map) }}, {{ coalitionBlue.bullseye | xyToLat(map) }}]),
            positioning: 'center-center',
            element: document.getElementById('markerBullseyeBlue'),
            stopEvent: false
        });
        map.addOverlay(markerBullseyeBlue);
        {% endif %}
        {% if side == 'red' or side == 'mission_maker' %}
        var markerBullseyeRed = new ol.Overlay({
            position: ol.proj.fromLonLat([{{ coalitionRed.bullseye | xyToLong(map) }}, {{ coalitionRed.bullseye | xyToLat(map) }}]),
            positioning: 'center-center',
            element: document.getElementById('markerBullseyeRed'),
            stopEvent: false
        });
        map.addOverlay(markerBullseyeRed);
        {% endif %}

        {# display zones @todo #}
        {% for zone in miz.mission.triggerZones %}
        {#{% set point = miz_service.canvasPosition(mapRange,canvasDimension,zone) %}#}
        {% if zone.stroke %}
        var circle = new ol.geom.Circle(ol.proj.transform([{{ zone.position | xyToLong(map) }}, {{ zone.position | xyToLat(map) }}], 'EPSG:4326', 'EPSG:3857'), {{ zone.radius }});
        var CircleFeature = new ol.Feature(circle);
        var vectorSource = new ol.source.Vector({
            projection: 'EPSG:4326',
        });

        vectorSource.addFeatures([CircleFeature]);
        var layer = new ol.layer.Vector({
            source: vectorSource,
            style: [
                new ol.style.Style({
                    stroke: new ol.style.Stroke({
                        color: '{{ zone.color | rgbaJs }}',
                        width: 3
                    }),
                    {# test to add text #}
                    {#
                        text: new ol.style.Text({
                            textAlign: "Start",
                            textBaseline: "Middle",
                            font: 'Normal 12px Arial',
                            text: 'Approximate Area',
                            fill: new ol.style.Fill({
                                color: '#ffa500'
                            }),
                            stroke: new ol.style.Stroke({
                                color: '#000000',
                                width: 3
                            }),
                            offsetX: 0,
                            offsetY: 0,
                            rotation: 0
                        })
                     #}
                })]
        });
        map.addLayer(layer);
        {% endif %}
        {% endfor %}

        {% for id,grp in miz.mission.groups %}
        {% if grp.id == group.id or grp.coalition.name == side or side == "mission_maker" or (grp.stroke or grp.displayWaypoint) %}
        {% for waypointNum,waypoint in grp.route.waypoints %}

        map.addOverlay(new ol.Overlay({
            position: ol.proj.fromLonLat([{{ waypoint.position | xyToLong(map) }}, {{ waypoint.position | xyToLat(map) }}]),
            positioning: 'center-center',
            element: document.getElementById('waypoint_{{ grp.id }}_{{ waypointNum }}'),
            stopEvent: false
        }));
        {% endfor %}
        {% endif %}
        {% endfor %}

        {% set numLayer=0 %}
        {% for id,grp in miz.mission.groups %}
        {% if grp.id == group.id or grp.coalition.name == side or side == "mission_maker" or (grp.stroke or grp.displayWaypoint) %}
        {% if grp.id != group.id %}
            layers[{{ numLayer+1 }}].setVisible(false);
        {% endif %}
        $("#btnToggleGroup{{ id }}").click(function () {
            layers[{{ numLayer+1 }}].setVisible(this.checked);
            if (this.checked) {
                $(".waypoint_{{ id }}").removeClass('hidden');
            }
            else {
                $(".waypoint_{{ id }}").addClass('hidden');
            }
            {% set numLayer=numLayer+1 %}
        });
        {% endif %}
        {% endfor %}

    });


</script>
